﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=5.2
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	Public manager As BleManager2
	Public currentStateText As String = "UNKNOWN"
	Public currentState As Int
	Public connected As Boolean = False
	Public ConnectedName As String
	Private ConnectedServices As List
	Public rp As RuntimePermissions
	Public SU As StringUtils
	Public SF As StringFunctions
	Public BC As ByteConverter
	Public firstRead As Boolean 
	Public gService, gCharNotify, gCharWrite As String
End Sub

Sub Service_Create
	manager.Initialize("manager")
'#define SERVICE_UUID           "6E400001-B5A3-F393-E0A9-E50E24DCCA9E" // UART service UUID
'#define CHARACTERISTIC_UUID_RX "6E400002-B5A3-F393-E0A9-E50E24DCCA9E"
'#define CHARACTERISTIC_UUID_TX "6E400003-B5A3-F393-E0A9-E50E24DCCA9E"
	gService    = "00000001-b5a3-f393-e0a9-e50e24dcca9e"
	gCharWrite  = "00001002-b5a3-f393-e0a9-e50e24dcca9e"
	gCharNotify = "00001003-b5a3-f393-e0a9-e50e24dcca9e"
	
End Sub

Sub Service_Start (StartingIntent As Intent)

End Sub

Public Sub ReadData
	For Each s As String In ConnectedServices
		manager.ReadData(s)
	Next
	
'	manager.ReadData2 ( gService, gCharNotify )
End Sub

Public Sub WriteData ( pTxt As String )
	Dim xByte() As Byte
	
	xByte = BC.StringToBytes ( pTxt, "UTF8" )
	manager.WriteData ( gService, gCharWrite, xByte )
End Sub


Public Sub Disconnect
	manager.Disconnect
	Manager_Disconnected
End Sub

Sub Manager_StateChanged (State As Int)
	Select State
		Case manager.STATE_POWERED_OFF
			currentStateText = "POWERED OFF"
		Case manager.STATE_POWERED_ON
			currentStateText = "POWERED ON"
		Case manager.STATE_UNSUPPORTED
			currentStateText = "UNSUPPORTED"
	End Select
	currentState = State
	CallSub(Main, "StateChanged")
End Sub

Sub Manager_DeviceFound (Name As String, Id As String, AdvertisingData As Map, RSSI As Double)
	Log("Found: " & Name & ", " & Id & ", RSSI = " & RSSI & ", " & AdvertisingData) 'ignore
	
	If Name.Contains ( "B4X") Then
		For Each k As Int In AdvertisingData.Keys
		 If k <> 0 Then
		  Dim b() As Byte = AdvertisingData.Get(k)
		  Log("Key: " & k & ", Value: " & BC.StringFromBytes(b, "utf8")  & " Hex: "  & BC.HexFromBytes(b ) )
		 End If
		Next

		ConnectedName = Name
		manager.StopScan
		manager.Connect2(Id, False) 'disabling auto connect can make the connection quicker
	End If
	
End Sub

Public Sub StartScan
	If manager.State <> manager.STATE_POWERED_ON Then
		Log("Not powered on.")
	Else If rp.Check(rp.PERMISSION_ACCESS_COARSE_LOCATION) = False Then
		Log("No location permission.")
	Else
		firstRead = True
		manager.Scan2(Null, False)
'		manager.Scan2(Array(gService), False)
	End If
End Sub

Sub Manager_DataAvailable (ServiceId As String, Characteristics As Map)
	CallSub3(Main, "DataAvailable", ServiceId, Characteristics)
End Sub

Sub Manager_Disconnected
	Log("Disconnected")
	connected = False
	CallSub(Main, "StateChanged")
End Sub

Sub Manager_Connected (services As List)
	Log("Connected")
	connected = True
	ConnectedServices = services
	CallSub(Main, "StateChanged")
	manager.SetNotify(gService, gCharNotify, True)

End Sub

'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy

End Sub
